/*
    $Id: spectral_factory.h 53 2009-11-01 18:03:28Z matwey $
    Copyright (C) 2009  Sternberg Astronomical Institute, MSU

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _SPECTRAL_FACTORY_H
#define _SPECTRAL_FACTORY_H

#include <string>

#include <boost/filesystem/path.hpp>
#include <boost/numeric/ublas/vector.hpp>

#include "vector_generator.h"
#include "weif.h"

using namespace boost::numeric;

class spectral_factory{
public:
	typedef Weights weight_type;
private:
	boost::filesystem::path m_response;
	boost::filesystem::path m_wdir;

	vector_generator< wf::lg_generator > m_basis_grid;
private:
	const boost::filesystem::path get_spectrum_filename( const std::string& spectype ) const;
public:
	spectral_factory(const boost::filesystem::path& wd, const boost::filesystem::path& response);
	~spectral_factory();

	const weight_type spectral( const std::string& spectype, const ublas::vector<double>& inner_diam, const ublas::vector<double>& outer_diam );
};

#endif //_SPECTRAL_FACTORY_H
